/****************************************************************************
 *
 * (C) Unpublished Copyright of Novell, Inc.  All Rights Reserved.
 *
 * No part of this file may be duplicated, revised, translated, localized
 * or modified in any manner or compiled, linked or uploaded or downloaded
 * to or from any computer system without the prior written permission of
 * Novell, Inc.
 *
 ****************************************************************************/

#ifndef	_NWDSDSA_HEADER_
#define	_NWDSDSA_HEADER_

#include "nwdstype.h"
#include "nwdsbuft.h"
#include "nwdsdc.h"

#ifdef __cplusplus
extern "C" {
#endif

NWDSCCODE NWFAR NWPASCAL	NWDSAddObject
(
	NWDSContextHandle		context,
	char		NWFAR *objectName,
	int32		NWFAR *iterationHandle,
	uint8		more,
	Buf_T		NWFAR *objectInfo
);

NWDSCCODE NWDSBackupObject
(
	NWDSContextHandle		context,
	char	NWFAR *objectName,
	int32	NWFAR *iterationHandle,
	Buf_T	NWFAR *objectInfo
);

NWDSCCODE NWDSCompare
(
	NWDSContextHandle		context,
	char	NWFAR *object,
	Buf_T	NWFAR *buf,
	uint8	NWFAR *matched
);

/*-----------------------------------------------------------------------------
 *		In the case that objectName is a partition root, the partitionRootObject
 *		is the same as the objectName
 */

NWDSCCODE NWFAR NWPASCAL	NWDSGetPartitionRoot
(
 	NWDSContextHandle	context,
	char	NWFAR *objectName,
	char	NWFAR *partitionRoot
);

NWDSCCODE NWDSList
(
	NWDSContextHandle		context,
	char		NWFAR *object,
	int32		NWFAR *iterationHandle,
	Buf_T		NWFAR *subordinates
);

NWDSCCODE NWAPI NWDSListContainers
(
   NWDSContextHandle context,
   char  NWFAR       *object,
   int32 NWFAR       *iterationHandle,
   Buf_T NWFAR       *subordinates
);

NWDSCCODE NWDSListByClassAndName
(
	NWDSContextHandle		context,
	char NWFAR				*objectName,
	char NWFAR				*className,
	char NWFAR				*subordinateName,
	int32 NWFAR				*iterationHandle,
	Buf_T NWFAR				*subordinates
);

NWDSCCODE NWAPI NWDSGetCountByClassAndName
(
   NWDSContextHandle context,
   char  NWFAR       *objectName,
   char  NWFAR       *className,
   char  NWFAR       *subordinateName,
   int32 NWFAR       *count
);

NWDSCCODE NWDSMapIDToName
(
	NWDSContextHandle		context,
	int		connID,
	uint32	objectID,
	char		NWFAR *object
);

NWDSCCODE NWDSMapNameToID
(
	NWDSContextHandle		context,
	int		connID,
	char		NWFAR *object,
	uint32	NWFAR *objectID
);

NWDSCCODE NWDSModifyObject
(
	NWDSContextHandle		context,
	char		NWFAR *objectName,
	int32		NWFAR *iterationHandle,
	uint8		more,
	Buf_T		NWFAR *changes
);

NWDSCCODE NWDSModifyDN
(
	NWDSContextHandle		context,
	char		NWFAR *objectName,
	char		NWFAR *newDN,
	uint8		deleteOldRDN
);

NWDSCCODE NWDSModifyRDN
(
	NWDSContextHandle		context,
	char		NWFAR *objectName,
	char		NWFAR *newDN,
	uint8		deleteOldRDN
);

NWDSCCODE NWDSMoveObject
(
	NWDSContextHandle		context,
	char		NWFAR *objectName,
	char		NWFAR *destParentDN,
	char		NWFAR	*destRDN
);

NWDSCCODE NWDSRead
(
	NWDSContextHandle		context,
	char		NWFAR *object,
	uint32	infoType,
	uint8	   allAttrs,
	Buf_T		NWFAR *attrNames,
	int32		NWFAR *iterationHandle,
	Buf_T		NWFAR *objectInfo
);

NWDSCCODE NWDSReadObjectInfo
(
	NWDSContextHandle					context,
	char					NWFAR *object,
	char					NWFAR *distinguishedName,
	Object_Info_T		NWFAR *objectInfo
);

NWDSCCODE NWDSRemoveObject
(
	NWDSContextHandle		context,
	char		NWFAR *object
);

NWDSCCODE NWDSRestoreObject
(
	NWDSContextHandle		context,
	char	NWFAR *objectName,
	int32	NWFAR *iterationHandle,
	uint8 more,
	uint32 size,
	uint8	NWFAR *objectInfo
);

NWDSCCODE NWDSSearch
(
	NWDSContextHandle		context,
	char		NWFAR *baseObjectName,
	int		scope,
	uint8		searchAliases,
	Buf_T		NWFAR *filter,
	uint32	infoType,
	uint8		allAttrs,
	Buf_T		NWFAR *attrNames,
	int32		NWFAR *iterationHandle,
	int32		countObjectsToSearch,
	int32		NWFAR *countObjectsSearched,
	Buf_T		NWFAR *objectInfo
);

NWDSCCODE NWDSOpenStream
(
	NWDSContextHandle		context,
	char		NWFAR *objectName,
	char		NWFAR *attrName,
	uint32	flags,
	int		NWFAR *fileHandle
);

NWDSCCODE NWDSWhoAmI
(
 	NWDSContextHandle	context,
	char	NWFAR *objectName
);

NWDSCCODE NWDSGetServerDN
(
	NWDSContextHandle context,
	int connID, 
	char NWFAR *serverDN
);
						
NWDSCCODE NWDSGetServerAddresses
(
	NWDSContextHandle context,
	int connID, 
	uint32 NWFAR *countNetAddress, 
	Buf_T NWFAR *netAddresses
);

NWDSCCODE NWAPI NWDSInspectEntry
(
   NWDSContextHandle context,
   char  NWFAR       *serverName,
   char  NWFAR       *objectName,
   Buf_T NWFAR       *errBuffer
);

NWDSCCODE NWAPI NWDSReadReferences
(
   NWDSContextHandle context,
   char     NWFAR    *serverName,
   char     NWFAR    *objectName,
   uint32            infoType,
   uint8             allAttrs,
   Buf_T    NWFAR    *attrNames,
   uint32            timeFilter,
   int32    NWFAR    *iterationHandle,
   Buf_T    NWFAR    *objectInfo
);

NWDSCCODE NWAPI NWDSExtSyncList
(
   NWDSContextHandle context,
   char        NWFAR *objectName,
   char        NWFAR *className,
   char        NWFAR *subordinateName,
   int32       NWFAR *iterationHandle,
   TimeStamp_T NWFAR *timeStamp,
   int               onlyContainers,
   Buf_T       NWFAR *subordinates
);

NWDSCCODE NWAPI NWDSExtSyncRead
(
   NWDSContextHandle context,
   char        NWFAR *objectName,
   uint32            infoType,
   uint8             allAttrs,
   Buf_T       NWFAR *attrNames,
   int32       NWFAR *iterationHandle,
   TimeStamp_T NWFAR *timeStamp,
   Buf_T       NWFAR *objectInfo
);

NWDSCCODE NWAPI NWDSExtSyncSearch
(
   NWDSContextHandle context,
   char        NWFAR *baseObjectName,
   int               scope,
   uint8             searchAliases,
   Buf_T       NWFAR *filter,
   TimeStamp_T NWFAR *timeStamp,
   uint32            infoType,
   uint8             allAttrs,
   Buf_T       NWFAR *attrNames,
   int32       NWFAR *iterationHandle,
   int32             countObjectsToSearch,
   int32       NWFAR *countObjectsSearched,
	Buf_T       NWFAR *objectInfo
);

NWDSCCODE NWAPI NWDSRemSecurityEquiv
(
   NWDSContextHandle context,
   char  NWFAR       *equalFrom,
   char  NWFAR       *equalTo
);

NWDSCCODE NWAPI NWDSAddSecurityEquiv
(
   NWDSContextHandle context,
   char  NWFAR       *equalFrom,
   char  NWFAR       *equalTo
);

#ifdef __cplusplus
}
#endif

#endif
