/****************************************************************************
*
* (C) Unpublished Copyright Novell, Inc. All Rights Reserved.
*
* No part of this file may be duplicated, revised, translated,
* localized or modified in any manner or compiled, linked or 
* uploaded or downloaded to or from any computer system without
* the prior written consent of Novell, Inc.
*
* NetWare C NLM Runtime Library source code
*
*****************************************************************************/

#ifndef _STDLIB_H_INCLUDED

#ifndef _SIZE_T_DEFINED_
#define _SIZE_T_DEFINED_
typedef unsigned size_t;
#endif

#ifndef _WCHAR_T_DEFINED_
#define _WCHAR_T_DEFINED_
#ifdef __cplusplus
typedef long char wchar_t;
#else
typedef unsigned short wchar_t;
#endif
#endif

#define NULL    0

#define RAND_MAX        32767u
#define EXIT_SUCCESS    0
#define EXIT_FAILURE    0xff
#define MB_CUR_MAX      1

typedef struct {
        int     quot;
        int     rem;
} div_t;

typedef struct {
        long    quot;
        long    rem;
} ldiv_t;


/*
 * The following sizes are the maximum sizes of buffers used by the _makepath()
 * and _splitpath() functions. They include space for the '\0' terminator.
 */

#define _MAX_PATH    255 /* maximum length of full pathname */
#define _MAX_SERVER  48  /* maximum length of server name */
#define _MAX_VOLUME  16  /* maximum length of volume component */
#define _MAX_DRIVE   3   /* maximum length of drive component */
#define _MAX_DIR     255 /* maximum length of path component */
#define _MAX_FNAME   9   /* maximum length of file name component */
#define _MAX_EXT     5   /* maximum length of extension component */
#define _MAX_NAME    13  /* maximum length of file name (with extension) */

#ifdef __cplusplus
extern "C" {
#endif

#ifdef  __INLINE_FUNCTIONS__

#if __WATCOMC__ < 950

extern int abs(
         int __j );

extern div_t div(
         int __numer,
         int __denom );

extern long int labs(
         long int  __j );

#define abs(x)      _inline_abs(x)
#define div(x,y)    _inline_div(x,y)
#define labs(x)     _inline_labs(x)

#else

#pragma intrinsic(abs, div, labs)

#endif

#ifndef NO_EXT_KEYS

#if __WATCOMC__ < 950

extern unsigned int _rotl(
         unsigned int   __value,
         unsigned int   __shift );

extern unsigned int _rotr(
         unsigned int   __value,
         unsigned int   __shift );

extern unsigned long _lrotl(
         unsigned long  __value,
         unsigned int   __shift );

extern unsigned long _lrotr(
         unsigned long  __value,
         unsigned int   __shift );

#define _rotl(x,n)  _inline__rotl(x,n)
#define _rotr(x,n)  _inline__rotr(x,n)
#define _lrotl(x,n) _inline__lrotl(x,n)
#define _lrotr(x,n) _inline__lrotr(x,n)

#else

#pragma intrinsic(_rotl,_rotr,_lrotl,_lrotr)

#endif

#endif

#endif

#ifndef NO_EXT_KEYS

extern char *ecvt(
         double      __val,
         int         __ndig,
         int        *__dec,
         int        *__sign );

extern void _exit(
         int         __status );

extern char *fcvt(
         double      __val,
         int         __ndig,
         int        *__dec,
         int        *__sign );

extern char *gcvt(
         double      __val,
         int         __ndig,
         char       *__buf );

extern char *itoa(
         int         __value,
         char       *__buf,
         int         __radix );

extern unsigned long _lrotl(
         unsigned long __value,
         unsigned int __shift );

extern unsigned long _lrotr(
         unsigned long __value,
         unsigned int __shift );

extern char *ltoa(
         long int    __value,
         char       *__buf,
         int         __radix );

extern void _makepath(
         char       *__path,
         const char *__drive,
         const char *__dir,
         const char *__fname,
         const char *__ext );

#ifndef max
extern int max(
         int         __a, 
         int         __b );
#endif

#ifndef min
extern int min(
         int         __a, 
         int         __b );
#endif

extern unsigned int _rotl(
         unsigned int __value,
         unsigned int __shift );

extern unsigned int _rotr(
         unsigned int __value,
         unsigned int __shift );

extern void _splitpath(
         const char *__path,
         char       *__drive,
         char       *__dir,
         char       *__fname,
         char       *__ext );

extern void swab( 
         char       *__src, 
         char       *__dest, 
         int         __num  );

extern char *ultoa(
         unsigned long int __value,
         char       *__buf,
         int         __radix );

extern char *utoa(
         unsigned int __value,
         char       *__buf,
         int         __radix );

extern int sys_nerr;

extern char *sys_errlist[];

#endif

extern void abort(
         void );

extern int abs(
         int         __j );

extern int atexit(
         register void (*__func)(void) );

extern double atof(
         const char *__nptr );

extern int atoi(
         const char *__nptr );

extern long int atol(
         const char *__nptr );

extern void *bsearch(
         const void *__key,
         const void *__base,
         size_t      __nmemb,
         size_t      __size,
         int       (*__compar)(const void *__pkey,const void *__pbase) );

extern void *calloc(
         size_t      __n,
         size_t      __size );

extern div_t div(
         int         __numer,
         int         __denom );

extern void exit(
         int         __status );

extern void free(
         void       *__ptr );

extern char *getenv(
         const char *__name );

extern long int labs(
         long int    __j );

extern ldiv_t ldiv(
         long int    __numer,
         long int    __denom );

extern void *malloc(
         size_t      __size );

extern int mblen(
         const char *__s,
         size_t      __n );

extern size_t mbstowcs(
         wchar_t    *__pwcs,
         const char *__s,
         size_t      __n );

extern int mbtowc(
         wchar_t    *__pwc,
         const char *__s,
         size_t      __n );

extern void qsort(
         void       *__base,
         size_t      __nmemb,
         size_t      __size,
         int       (*__compar)(const void *,const void *) );

extern int rand(
         void );

extern void *realloc(
         void       *__ptr,
         size_t      __size );

extern void srand(
         unsigned int __seed );

extern double strtod(
         const char *__nptr,
         char      **__endptr );

extern long int strtol(
         const char *__nptr,
         char      **__endptr,
         int         __base );

extern unsigned long int strtoul(
         const char *__nptr,
         char      **__endptr,
         int         __base );

extern int system(
         const char *__string );

extern size_t wcstombs(
         char       *__s,
         const wchar_t *__pwcs,
         size_t      __n );

extern int wctomb(
         char       *__s,
         wchar_t     __wchar );

#ifdef __cplusplus
}
#endif

#define atof(p) strtod(p,(char **)NULL)

#define _STDLIB_H_INCLUDED
#endif
